package de.erethon.hephaestus;

import net.minecraft.resources.ResourceLocation;
import net.minecraft.world.item.ItemStack;

import java.util.ArrayList;
import java.util.List;

import static net.minecraft.server.MinecraftServer.LOGGER;

public class HItemStack {

    private HItem item;
    private ItemStack stack;
    private int level = 0;
    private HRarity rarity = HRarity.COMMON;
    private List<Slotable> slotted = new ArrayList<>();


    public HItemStack(ItemStack stack, HItem config) {
        this.stack = stack;
        this.item = config;
    }

    public HItemStack(ItemStack stack, HItem config, int level) {
        this.stack = stack;
        this.item = config;
        this.level = level;
    }

    public HItemStack(ItemStack stack, HItem config, int level, HRarity rarity) {
        this.stack = stack;
        this.item = config;
        this.level = level;
        this.rarity = rarity;
    }

    public ResourceLocation getId() {
        return item.getId();
    }

    public boolean needsUpdating(ItemStack stack) {
        return !ItemStack.matches(stack, this.stack);
    }

    public ItemStack getStack() {
        return stack;
    }

    public org.bukkit.inventory.ItemStack getBukkitStack() {
        return stack.getBukkitStack();
    }

    public HItemBehaviour getBehaviour() {
        return item.getBehaviour();
    }

    public HItem config() {
        return item;
    }

    public boolean isEnabled() {
        return item.isEnabled();
    }

    public boolean isVanilla() {
        return item.getId().getNamespace().equals("minecraft");
    }

    public HItemStack replaceWith() {
        return item.getReplaceWith();
    }

    public void setStack(ItemStack stack) {
        this.stack = stack;
    }

    public void validate() {
    }
}
