package de.erethon.papyrus;

import net.minecraft.world.entity.ai.attributes.Attribute;
import net.minecraft.world.entity.ai.attributes.Attributes;

import java.util.Arrays;

public enum CraftDamageType {

    AIR(Attributes.ADV_AIR, Attributes.RES_AIR, Attributes.PEN_MAGICAL, PDamageType.AIR),
    EARTH(Attributes.ADV_EARTH, Attributes.RES_EARTH, Attributes.PEN_MAGICAL, PDamageType.EARTH),
    FIRE(Attributes.ADV_FIRE, Attributes.RES_FIRE, Attributes.PEN_MAGICAL,PDamageType.FIRE),
    MAGIC(Attributes.ADV_MAGIC, Attributes.RES_MAGIC, Attributes.PEN_MAGICAL,PDamageType.MAGIC),
    PHYSICAL(Attributes.ADV_PHYSICAL, Attributes.RES_PHYSICAL, Attributes.PEN_PHYSICAL,PDamageType.PHYSICAL),
    WATER(Attributes.ADV_WATER, Attributes.RES_WATER, Attributes.PEN_MAGICAL,PDamageType.WATER),
    PURE(Attributes.ADV_PURE, Attributes.RES_PURE, Attributes.PEN_PHYSICAL, PDamageType.PURE);

    private final Attribute advAttr;
    private final Attribute resAttr;

    private final Attribute penAttribute;
    private final PDamageType apiDamageType;

    CraftDamageType(Attribute advAttr, Attribute resAttr, Attribute penAttribute, PDamageType apiDamageType) {
        this.advAttr = advAttr;
        this.resAttr = resAttr;
        this.penAttribute = penAttribute;
        this.apiDamageType = apiDamageType;
    }

    public Attribute getAdvAttr() {
        return this.advAttr;
    }


    public Attribute getResAttr() {
        return this.resAttr;
    }

    public Attribute getPenAttribute() {
        return this.penAttribute;
    }


    public static CraftDamageType ofAPI(PDamageType type) {
        return Arrays.stream(values()).filter(crafttype -> crafttype.apiDamageType == type).findFirst().orElse(null);
    }

    public PDamageType getApiDamageType() {
        return apiDamageType;
    }
}
