package de.erethon.papyrus;

import net.minecraft.core.NonNullList;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.item.ItemStack;
import org.bukkit.event.Event;
import org.bukkit.event.HandlerList;
import org.jetbrains.annotations.NotNull;

public class PlayerInventoryLoadEvent extends Event {

    private static final HandlerList handlers = new HandlerList();

    private Player player;
    private NonNullList<ItemStack> items;
    private NonNullList<ItemStack> armor;
    private NonNullList<ItemStack> offhand;

    public PlayerInventoryLoadEvent(Player player, NonNullList<ItemStack> itemStacks, NonNullList<ItemStack> armor, NonNullList<ItemStack> offhand) {
        this.player = player;
        this.items = itemStacks;
        this.armor = armor;
        this.offhand = offhand;
    }

    public Player getPlayer() {
        return player;
    }

    public NonNullList<ItemStack> getItems() {
        return items;
    }

    public NonNullList<ItemStack> getArmor() {
        return armor;
    }

    public NonNullList<ItemStack> getOffhand() {
        return offhand;
    }

    @NotNull
    @Override
    public HandlerList getHandlers() {
        return handlers;
    }

    public static HandlerList getHandlerList() {
        return handlers;
    }
}
